'=============
'TestSuite.vbs
'=============
'
'Meant to be used to verify that the PScript.exe script host works
'and that the global properties and methods it provides all work.
'
'FOR TESTING:
'
'This script should be in the same directory as PScript.exe since
'it runs another copy of PScript.exe to test Run.
'
'This directory should contain a subdirectory "test abc" which
'contains some files and subfolders because this script tests
'CopyDir by copying the "test abc" directory to a "work" directory
'and later RmDir with the Deep argument True to clean up the work
'directory.
'
'Open a Cmd.exe console, set CD to the directory containing
'PScript.exe and this script.
'
'TESTS:
'
'   pscript
'
'   pscript /?
'
'   pscript //:T0 testsuite.vbs
'
'   pscript testsuite.xxx
'
'   pscript testsuite.vbs
'
'   pscript testsuite.vbs a b "quoted arg" d
'
'   pscript testsuite.vbs //t:-1 a b "quoted arg" d
'
'   pscript testsuite.vbs //t:1 a b "quoted arg" d
'
'   pscript testsuite.vbs //t:0 a b "quoted arg" d
'
Option Explicit

Private Text, I, Temp, Work

'------------------------------------------------------------
MsgBox AppDataLocal, vbOkOnly Or vbInformation, "AppDataLocal"

'------------------------------------------------------------
Text = "Count = " & CStr(Arguments.Count)
For I = 1 To Arguments.Count
    Text = Text & vbNewLine & CStr(I) & " = " & Arguments(I)
Next
MsgBox Text, vbOkOnly Or vbInformation, "Arguments"

'------------------------------------------------------------
MsgBox "{" & ArgumentsLine & "}", vbOkOnly Or vbInformation, "ArgumentsLine"

'------------------------------------------------------------
Temp = CD
Text = Temp & vbNewLine
CD = ".."
Text = Text & CD & vbNewLine
CD = Temp
MsgBox Text & CD, vbOkOnly Or vbInformation, "CD"

'------------------------------------------------------------
Work = RndSubdirOf(ScriptPath)
MsgBox "RndSubdirOf(ScriptPath) =" & vbNewLine & Work, vbOkOnly Or vbInformation, "RndSubdirOf"

'------------------------------------------------------------
CopyDir "test abc", Work
MsgBox "Check for Work directory!", vbOkOnly Or vbQuestion, "CopyDir"

'------------------------------------------------------------
CopyFile "TestSuite.vbs", Work & "\Junk.vbs"
MsgBox "Check for ""<Work>\Junk.vbs""", vbOkOnly Or vbQuestion, "CopyFile"

'------------------------------------------------------------
Del Work & "\Junk.*"
MsgBox "Check for ""<Work>\Junk.vbs"" GONE", vbOkOnly Or vbQuestion, "Del"

'------------------------------------------------------------
MsgBox Environment("WinDir"), vbOkOnly Or vbInformation, "Environment test 1"

'------------------------------------------------------------
Text = ""
I = 0
Do
    I = I + 1
    Temp = Environment(I)
    Text = Text & Temp & vbNewLine
Loop While Len(Temp) > 0
MsgBox Text, vbOkOnly Or vbInformation, "Environment test 2"

'------------------------------------------------------------
MsgBox CStr(Exists("no-such-file.at-all")), vbOkOnly Or vbInformation, "Exists"

'------------------------------------------------------------
MsgBox ExpandEnvironmentStrings("%APPDATA%\Testing\Testing"), vbOkOnly Or vbInformation, "ExpandEnvironmentStrings"

'------------------------------------------------------------
MkDir "deleteme"
MsgBox "Check for ""deleteme"" directory", vbOkOnly Or vbQuestion, "MkDir"

'------------------------------------------------------------
Rename "deleteme", "removeme"
MsgBox "Check for ""removeme"" directory", vbOkOnly Or vbQuestion, "Rename"

'------------------------------------------------------------
RmDir "removeme"
MsgBox "Check for ""removeme"" directory GONE", vbOkOnly Or vbQuestion, "RmDir"

'------------------------------------------------------------
RmDir Work, True
MsgBox "Check for Work directory GONE", vbOkOnly Or vbQuestion, "RmDir DEEP"

'------------------------------------------------------------
MsgBox "Run result = " & CStr(Run("PScript", "-?", , True)), vbOkOnly Or vbInformation, "Run"

'------------------------------------------------------------
MsgBox ScriptFullName, vbOkOnly Or vbInformation, "ScriptFullName"

'------------------------------------------------------------
MsgBox ScriptPath, vbOkOnly Or vbInformation, "ScriptPath"

'------------------------------------------------------------
MsgBox "Going to sleep for 3 seconds", vbOkOnly Or vbInformation, "Sleep"
For I = 1 To 3
    Sleep 1000 'Sleep 1 second.
Next
MsgBox "Running again", vbOkOnly Or vbInformation, "Sleep"

'------------------------------------------------------------
MsgBox "Quitting now...", vbOkOnly Or vbInformation, "Quit"
Quit
MsgBox "Should not get here!", vbOkOnly Or vbExclamation, "Quit"
